//===============================
// Title: Full Exception
// Author: Jincux
//===============================

if(isFunction(RTB_registerPref))
	RTB_registerPref("Allow", "Full Exception", "$FullException::Mode", "list Off 0 Host 1 Super 2 Admin 3", "Full Server Join Exception", 3, false, true, false);
else
	$FullException::Mode = 3;
	
package FullException
{
	function GameConnection::onConnectRequest(%client, %ip, %lan, %net, %prefix, %suffix, %arg5, %rtb, %arg7, %arg8, %arg9, %arg10, %arg11, %arg12, %arg13, %arg14, %arg15)
	{
		%actualMax = $Pref::Server::MaxPlayers;
		if(ClientGroup.getCount() >= $Pref::Server::MaxPlayers)
		{
			if(getNumKeyId() $= %client.bl_id && $FullException::Mode >= 1)
				%isAdmin = 1;
			
			if(!%isAdmin && $FullException::Mode >= 3)
			{
				for(%i = 0; %i < getWordCount($Pref::Server::AutoAdminList); %i++)
				{
					if(getWord($Pref::Server::AutoAdminList, %i) $= %client.bl_id)
					{
						%isAdmin = 1;
						break;
					}
				}
			}
			
			if(!%isAdmin && $FullException::Mode >= 2)
			{
				for(%i = 0; %i < getWordCount($Pref::Server::AutoSuperAdminList); %i++)
				{
					if(getWord($Pref::Server::AutoSuperAdminList, %i) $= %client.bl_id)
					{
						%isAdmin = 1;
						break;
					}
				}
			}
			
			if(%isAdmin && $Pref::Server::MaxPlayers < 99)
				$Pref::Server::MaxPlayers = ClientGroup.getCount() + 1;
		}
		
		%ret = parent::onConnectRequest(%client, %ip, %lan, %net, %prefix, %suffix, %arg5, %rtb, %arg7, %arg8, %arg9, %arg10, %arg11, %arg12, %arg13, %arg14, %arg15);
		
		$Pref::Server::MaxPlayers = %actualMax;
		return %ret;
	}
};

activatePackage(FullException);
